{***********************************************}
{                                               }
{                 by MEROUANE K                 }
{              www.Delphi4Arab.com              }
{               18/05/2008 06:00                }
{           Free Toturial /Open Source          }
{***********************************************}


unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ToolWin, Menus, Buttons, ColorGrd, ExtCtrls, StdCtrls,
  ExtDlgs;

type
  TForm1 = class(TForm)
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    SBNew: TSpeedButton;
    SBOpen: TSpeedButton;
    SBErease: TSpeedButton;
    SBSave: TSpeedButton;
    Panel1: TPanel;
    Panel3: TPanel;
    Panel2: TPanel;
    ColorGrid1: TColorGrid;
    Panel4: TPanel;
    Panel5: TPanel;
    PBackGr: TPanel;
    PForGr: TPanel;
    Panel8: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Panel9: TPanel;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    SpeedButton7: TSpeedButton;
    SpeedButton8: TSpeedButton;
    SpeedButton9: TSpeedButton;
    SpeedButton12: TSpeedButton;
    Image1: TImage;
    OpenPic1: TOpenPictureDialog;
    SavePic1: TSavePictureDialog;
    procedure Label1Click(Sender: TObject);
    procedure Panel8MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure ColorGrid1Click(Sender: TObject);
    procedure SBNewClick(Sender: TObject);
    procedure SpeedButton10Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SBOpenClick(Sender: TObject);
    procedure SBSaveClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;
  Mode: integer = 0;
  xB,yB,x0,y0: integer;
  CanPaint: Boolean = false;

implementation

{$R *.dfm}

procedure TForm1.Label1Click(Sender: TObject);
begin
 Label6.Top:=(Sender as TLabel).Tag;
 Image1.Canvas.Pen.Width := (Sender as TLabel).Tag;
end;

procedure TForm1.Panel8MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  case y of
    0..9   : Label1Click(Label1);
    10..19 : Label1Click(Label2);
    20..29 : Label1Click(Label3);
    30..39 : Label1Click(Label4);
    40..55 : Label1Click(Label5);
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 ColorGrid1Click(Self);
end;

procedure TForm1.ColorGrid1Click(Sender: TObject);
begin
 PBackGr.Color := ColorGrid1.BackgroundColor;
 PForGr.Color := ColorGrid1.ForegroundColor;
end;

procedure TForm1.SBNewClick(Sender: TObject);
begin
image1.Visible:=true;
 with Image1.Canvas do
 begin
  Brush.Color:=clWhite;
  FillRect(rect(0,0,Width,Height));
  Brush.Color:=clBlack;
 end;
SBErease.Enabled:=true;
CanPaint:=True;
end;

procedure TForm1.SpeedButton10Click(Sender: TObject);
begin
  Image1.Canvas.Pen.Width := (Sender as TLabel).Tag;
end;

procedure TForm1.SpeedButton5Click(Sender: TObject);
begin
 Mode:=(Sender as TSPeedButton).Tag;
end;

procedure TForm1.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var C: TColor;
begin
 if CanPaint = true then
 with Image1.Canvas do
 begin
 if (ssleft in Shift)or (ssRight in Shift) then
 begin
  if (ssleft in Shift) then
    begin
    Pen.Color:=PBackGr.Color;
    Brush.Color:= PForGr.Color;
    end
    else if (ssRight in Shift) then
           begin
           Pen.Color:=PForGr.Color;
           Brush.Color:=PBackGr.Color;
           end;
  case mode of
    0: LineTo(x,y);  // Pen
    1: begin          // Erease      
        C := pen.Color;
        pen.Color:=clWhite;
        lineto(x,y);
        pen.Color := C;
       end;
    2: FillRect(rect(0,0,Width,Height));  // Fill
    3: Pixels[x0+random(x0),y0+random(y0)]:=Pen.Color;
    4: begin          // Rectangle
        pen.Mode:=pmXor;
        Rectangle (xB,yB,x0,y0);
        Rectangle (xB,yB,x,y);
       end;
    5: begin          // Cercle
        pen.Mode:=pmXor;
        Ellipse(xB,yB,x0,y0);
        Ellipse(xB,yB,x,y);
       end;
  end;
 end;
 end;
  x0:=x ;
  y0:=y;
  Image1.Canvas.Pen.Mode:=pmCopy;
end;

procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 image1.Canvas.MoveTo(x,y);
 xB := x;
 yB := y;
end;

procedure TForm1.Image1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
if CanPaint = true then
 with Image1.Canvas do
  case mode of
    4: begin          // Rectangle
        pen.Mode:=pmCopy;
        Rectangle (xB,yB,x,y);
       end;
    5: begin          // Cercle
        pen.Mode:=pmCopy;
        Ellipse(xB,yB,x,y);
       end;
  end;
end;

procedure TForm1.SBOpenClick(Sender: TObject);
begin
 if OpenPic1.Execute then
  begin
  image1.Visible:=true;
  Image1.Picture.LoadFromFile(OpenPic1.FileName);
  SBErease.Enabled:=true;
  CanPaint:=True;
 end;
end;

procedure TForm1.SBSaveClick(Sender: TObject);
begin
   if SavePic1.Execute then
  begin
  Image1.Picture.SaveToFile(SavePic1.FileName);
 end;
end;

end.
